@import 'variables.scss';
@import 'flip-card.scss';
@import '../../../../styles/common.scss';
@import 'flex.scss';

:host {
  --leading-color: #065066;
  --secondary-color: $secondary-color;
  --background-color: $background-color;
  --border-color: #d4d3d4;
  --success-color: $success-color;
  --trend-color: $trend-color;
  --popup-color: $popup-color;
  --widget-font: Arial;
  --widget-font-size: 11px;
  --widget-font-color: #7d7c7c;
  --widget-font-accent-color: #065066;
  --title-font: Arial;
  --title-font-color: var(--widget-font-accent-color);
  --title-font-size: 14px;
  --title-border-color: var(--widget-font-accent-color);
  --title-border-size: 3px;
  --bar-chart-color: var(--widget-font-accent-color);
  --line-chart-color: #9ae9fe;
  --line-chart-thickness: 3;
  --hover-background-color: #ffffff;
  --hover-font-color: #000;
  --kpi1-font-size: 24px;
  --kpi1-font-color: var(--widget-font-accent-color);
  --kpi2-font-size: 24px;
  --kpi2-font-color: var(--widget-font-accent-color);
  --kpi3-font-size: 24px;
  --kpi3-font-color: var(--widget-font-accent-color);
  --kpi4-font-size: 24px;
  --kpi4-font-color: var(--widget-font-accent-color);
  --icon-color: #707070;
}

.hide {
  display: none !important;
}

#sac-widget-name,
#sac-widget-name-back {
  font-size: var(--title-font-size);
  font-family: var(--title-font);
  border: 0;
  line-height: 24px;
  outline: none;
  margin-left: 2px;
  margin-bottom: 18px;
  color: var(--title-font-color);
  border-bottom-style: solid;
  border-bottom-color: var(--title-border-color);
  border-bottom-width: var(--title-border-size);
}

#sac-widget-name-back {
  border: 0;
  color: var(--secondary-color);
}

.widget-container {
  background-color: #fff;
  font-family: var(--widget-font);
  font-size: var(--widget-font-size);
  color: var(--widget-font-color);
  box-sizing: border-box;
  min-height: 100%;
  width: 100%;
  overflow: hidden;
  position: relative;

  input {
    font-family: var(--widget-font);
    font-size: var(--widget-font-size);
    color: var(--widget-font-color);
    width: 100%;

    &.tile-title {
      width: auto;
    }
  }

  .compare-values-container {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
    align-items: center;
    height: 100%;
  }

  input.desc,
  input.comp-value-desc {
    border: 0;
    background-color: transparent;
    display: block;
    outline: 0;
  }

  .comp-wrapper {
    flex: 1 1 50%;
    height: 30px;
    display: flex;
    align-items: center;
    flex-direction: row;

    > * {
      // flex: 1 auto;
    }

    > label {
      // max-width: 50px;
      // min-width: 50px;
      // text-align: right;
    }

    > i {
      flex: none;
    }
  }

  input.comp-value-desc {
    margin: 0;
    padding: 0;
  }

  .value {
    font-size: 23px;
    color: var(--widget-font-accent-color);

    &.big {
      font-size: 32px;
    }
  }

  .comp-value {
    display: none;
    font-size: 23px;
    color: var(--widget-font-accent-color);
  }

  &.runtime {
    .flip-card-button,
    .unflip-card-button {
      display: block;
    }

    .value {
      &:hover {
        text-decoration: underline;
      }
    }

    .overlay {
      .comp-value {
        display: block;
      }

      span.value {
        text-decoration: none;
        pointer-events: none;
      }

      .compare-values-container {
        display: block;
        margin-top: 10px;
        height: unset;

        &.icons {
          .comp-wrapper {
            display: flex;
            flex-direction: row;
            align-items: center;
          }
        }
      }

      .flex-container {
        flex: none;
        display: block;
      }

      .comp-wrapper {
        display: flex;
        flex-direction: row;
        flex-wrap: wrap;
        align-items: baseline;
        height: 45px;

        > * {
          flex: none;
        }

        > label {
          max-width: unset;
          min-width: auto;
          order: 3;

          &.hide {
            display: block !important;
          }
        }

        > i {
          flex: none;
          order: 2;
          display: none;
        }

        > .comp-container {
          order: 1;
          min-width: 100%;
        }

        > span {
          order: 2;
          padding-right: .5em;
        }
      }
    }
  }
}

h1 {
  font-weight: bold;
}

rect {
  fill: var(--bar-chart-color);
}

.line {
  fill: none;
  stroke: var(--line-chart-color);
  stroke-width: var(--line-chart-thickness);
}

label.comp-label {
  display: block;
  box-sizing: border-box;
  margin-right: 4px;

  &.positive {
    color: green;

    &:before {
      content: '+';
    }
  }

  &.negative {
    color: red;
  }

  &.accent {
    color: var(--trend-accent-color) !important;
  }
}

i.comp-trend {
  box-sizing: border-box;
  width: 7px;
  height: 4px;
  margin-top: 12px;
  margin-left: 3px;
  margin-right: 3px;
  margin-bottom: 10px;

  &.accent {
    background-color: var(--trend-accent-color) !important;
  }

  &.icon-set1 {
    width: 16px;
    height: 8px;

    &.yellow {
      width: 8px;
      height: 16px;
      margin-left: 7px;
      margin-right: 7px;
    }
  }

  &.icon-set2 {
    width: 16px;
    height: 16px;
  }

  &.icon-set3 {
    width: 14px;
    height: 8px;

    &.yellow {
      width: 10px;
      height: 10px;
      margin-right: 5px;
      margin-left: 5px;
    }
  }

  // &.positive {
  //   border: 0;
  //   width: 0;
  //   height: 0;
  //   border-radius: 0;
  //   margin-left: 0;
  //   border-left: 5px solid transparent;
  //   border-right: 5px solid transparent;
  //   border-bottom: 8px solid $leading-color;
  // }

  // &.negative {
  //   border: 0;
  //   width: 0;
  //   height: 0;
  //   border-radius: 0;
  //   margin-left: 0;
  //   border-left: 5px solid transparent;
  //   border-right: 5px solid transparent;
  //   border-top: 8px solid $leading-color;
  // }
}

.panel-toggler {
  box-sizing: border-box;
  height: 25px;
  position: absolute;
  border-radius: 0px;
  left: 0px;
  top: 14px;
  width: 12px;
  padding: 0;
  border: 0;
  cursor: pointer;
  background-color: var(--icon-color);

  &:hover {
    background-color: $leading-color;
  }

  .arrow-left {
    margin-left: 1px;
    margin-right: 2px;
    height: 0;
    border-top: 8px solid transparent;
    border-bottom: 8px solid transparent;
    border-right: 8px solid #fff;
  }
}

.flip-card-front,
.flip-card-back {
  padding: 12px;
  box-sizing: border-box;
  z-index: 1;
}

.flip-card-button,
.unflip-card-button {
  display: none;
  position: absolute;
  top: 14px;
  right: 14px;
  border: solid 3px var(--icon-color);
  background-color: var(--icon-color);
  padding: 0;
  width: 18px;
  height: 18px;
  font-size: 18px;
  border-radius: 12px;
  line-height: 7px;
  color: #fff;
  font-weight: bold;
}

.unflip-card-button {
  font-size: 11px;
}

.flipped {
  .flip-card-button {
    display: none !important;
  }
}

p.description {
  font-size: 16px;
  color: $secondary-color;
}

.comp-wrapper {
  flex: 1 auto;
}

.toolTip {
  position: absolute;
  display: none;
  min-width: 40px;
  height: auto;
  background: var(--hover-background-color);
  color: var(--hover-font-color);
  border-style: solid;
  border-width: 1px;
  border-color: var(--border-color);
  padding: 10px;
  border-radius: 2px;
  box-shadow: 0px 3px 6px #00000029;

  span {
    display: block;
    white-space: nowrap;
  }
}

.svg-container:empty {
  display: none;
}

.svg-container {
  // position: absolute;
  // min-height: 120px;
  // width: calc(100% - 20px);
  // bottom: 0;
  box-sizing: border-box;
  flex: 1 1 auto;

  svg {
    height: 100%;
  }

  &:empty {
    display: none;
  }
}

.flip-card-front {
  display: flex;
  flex-direction: column;
  height: 100%;
}

.kpis-wrapper {
  display: flex;
  flex-direction: column;
  flex: 1 1 auto;
}

#kpi-1-value {
  font-size: var(--kpi1-font-size);
  color: var(--kpi1-font-color);
}

#kpi-2-value {
  font-size: var(--kpi2-font-size);
  color: var(--kpi2-font-color);
}

#kpi-3-value {
  font-size: var(--kpi3-font-size);
  color: var(--kpi3-font-color);
}

#kpi-4-value {
  font-size: var(--kpi4-font-size);
  color: var(--kpi4-font-color);
}

.yellow {
  color: var(--trend-equals-color);
}

.red {
  color: var(--trend-minus-color);
}

i.comp-trend.red {
  background-color: var(--trend-minus-color);
}

i.comp-trend.yellow {
  background-color: var(--trend-equals-color);
}

i.comp-trend.green {
  background-color: var(--trend-plus-color);
}

.green {
  color: var(--trend-plus-color);
}

i.switch {
  width: 38px;
  height: 10px;
  cursor: pointer;
  border: solid 1px var(--icon-color);
  display: inline-flex;
  flex-direction: row;
  flex-wrap: wrap;
  align-items: center;
  justify-content: space-evenly;
  text-align: center;
  font-style: normal;
  font-size: 9px;

  .abs, .percent {
    flex: 1;
  }

  &.absolute {
    
    > .abs {
      background-color: var(--icon-color);
      color: #fff;
    }

    > .percent {
      color: var(--icon-color);
      background-color: #fff;
    }
  }

  &.percentage {
    
    > .abs {
      color: var(--icon-color);
      background-color: #fff;
    }

    > .percent {
      background-color: var(--icon-color);
      color: #fff;
    }
  }
}

.description-wrapper {
  display: flex;
  flex-direction: row;
}
.desc {
  flex: 0.5;
}